cryptol-2.4.0: Cryptol: The Language of Cryptography

Copyright | (c) 2013-2016 Galois Inc.
License | BSD3
Maintainer | cryptol@galois.com
Stability | provisional
Portability | portable
Safe Haskell | Safe
Language | Haskell98

Cryptol.Eval.Type

Description

Synopsis

- evalType :: EvalEnv -> Type -> Either Nat' TValue
- evalValType :: EvalEnv -> Type -> TValue
- evalNumType :: EvalEnv -> Type -> Nat'
- evalTF :: TFun -> [Nat'] -> Nat'

# Documentation

evalType :: EvalEnv -> Type -> Either Nat' TValue Source #

Evaluation for types (kind * or #).

evalValType :: EvalEnv -> Type -> TValue Source #

Evaluation for value types (kind *).

evalNumType :: EvalEnv -> Type -> Nat' Source #

evalTF :: TFun -> [Nat'] -> Nat' Source #

Reduce type functions, raising an exception for undefined values.